var __log = (window.console !== undefined) ? window.console.log.bind(console) : function () {},
    __err = (window.console !== undefined) ? window.console.error.bind(console) : function () {},
    __warn = (window.console !== undefined) ? window.console.warn.bind(console) : function () {},
    cin = cin || {};
cin.plugin = cin.plugin || {};
cin.plugin.banners = cin.plugin.banners || {};
cin.plugin.banners.isStarted = cin.plugin.banners.isStarted || false;
cin.plugin.banners.app = {
    cfg: cin.plugin.banners.config || {},
    checkoutApp: cin.plugin.banners.app || {},
    app: cin.plugin.banners.app || {},
    pcon: null,
    loading: null,
    init: function () {
        if (cin.plugin.banners.isStarted) {
            return;
        }
        cin.plugin.banners.isStarted = true;
        var that = this;
        try {
            $('.banners-timeTo').each(function () {
                __log($(this).attr('id'), $(this).attr('data-date'));
                var dDate = bannerDate($(this).attr('data-date'));
                $('#' + $(this).attr('id')).bannerTimeTo({
                    bannerTimeTo: dDate,
                    displayCaptions: false,
                    displayCaptionsOnTarget: true,
                    captionsTarget: '#' + $(this).attr('id') + 'Caption',
                    displayDays: 2,
                    captionSize: 10,
                    fontSize: 12,
                    theme: ''
                });
            });
        }
        catch (ex) {
            __warn('time-to problem:', ex);
        }
    },
    toString: function (value, fieldDecimal) {
        switch (typeof value) {
            case 'int':
            case 'number':
            case 'integer':
            case 'float':
                fieldDecimal = (!this.empty(fieldDecimal) ? parseInt(fieldDecimal) : 2);
                var sValue = this.parseFloat(value).toFixed(fieldDecimal).
                    toLocaleString('de-DE', {minimumFractionDigits: 2}).
                    replace(',', '').replace('.', ',');
                //var substr = sValue.substring(0, sValue.indexOf(',')),
                //    len = substr.length;
                //for (var len_i = len - 3; len_i > 0; len_i -= 3) {
                //    sValue = sValue.substring(0, len_i) + '.' + sValue.substring(len_i);
                //}
            case 'string':
                return sValue;
                break;
        }
        //__log('toString:', typeof value, value, '[X]');
        return '';
    },
    parseFloat: function (value) {
        switch (typeof value) {
            case 'string':
                value = value.replace('.', '').replace(',', '.');
            case 'int':
            case 'number':
            case 'integer':
                var fValue = parseFloat(value);
                //__log('parseFloat:', typeof value, value, fValue);
                return fValue;
                break;
            case 'float':
                //__log('parseFloat:', typeof value, value);
                return value;
                break;
        }
        //__log('parseFloat:', typeof value, value, 0, '[X]');
        return 0;
    },
    setFixedFloat: function (field, value) {
        try {
            var fieldValue = this.parseFloat(value),
                fieldDecimal;
            if (isNaN(fieldValue)) {
                //__log('setFixedFloat:', $(field), fieldValue, '-> isNAN');
                return false;
            }

            fieldDecimal = $(field).attr('data-decimal');
            //__log('setFixedFloat:', $(field), fieldValue, fieldDecimal);
            $(field).attr('value', this.toString(fieldValue, fieldDecimal));
            return true;
        }
        catch (ex) {
            return false;
        }
    },
    setFixedFloatHTML: function (field, value, addon) {
        try {
            var fieldValue = this.parseFloat(value);
            //__log('setFixedFloatHTML:', $(field), value, fieldValue, this.toString(fieldValue, 2));
            //if (isNaN(fieldValue)) {
            //    return;
            //}
            var sValue = this.toString(fieldValue, 2);
            var substr = sValue.substring(0, sValue.indexOf(',')),
                len = substr.length;
            for (var len_i = len - 3; len_i > 0; len_i -= 3) {
                sValue = sValue.substring(0, len_i) + '.' + sValue.substring(len_i);
            }
            sValue += !this.empty(addon) ? (' ' + addon) : '';
            $(field).html(sValue);
            //__log('setFixedFloatHTML:', $(field), $(field).html(), this.toString(fieldValue, 2));
        }
        catch (ex) {
            __log('setFixedFloatHTML:', ex);
        }
    },
    className: function (value) {
        value = value.replace(/^[a-zA-Z0-9-_]/g, '');
        value = value.replace(/--/g, '-');
        return value;
    },
    contentWidth: function () {
        return $('body').width() > 0 ? $('body').width() : window.innerWidth;
    },
    contentHeight: function () {
        return $('body').height() > 0 ? $('body').height() : window.innerHeight;
    },
    findBootstrapWidth: function () {
        var envs = ['xs', 'sm', 'md', 'lg'],
            breakpoints = [480, 768, 992, 1020],
            contentWidth = this.contentWidth();
        //__log('art::findBootstrapWidth', envs, breakpoints, contentWidth);
        for (i = envs.length - 1; i >= 0; i--) {
            if (contentWidth > breakpoints[i]) {
                return envs[i];
            }
        }
        return '';
    },
    empty: function (chkValue) {
        try {
            switch (typeof chkValue) {
                case 'undefined':
                case 'null':
                    return true;
                    break;
                case 'string':
                    return !(chkValue.length > 0);
                    break;
                case 'array':
                case 'object':
                    return !(Object.keys(chkValue).length > 0);
                    break;
                case 'float':
                case 'integer':
                    return !(chkValue != 0);
                    break;
            }
        }
        catch (ex) {
            __log(chkValue, ex);
        }
        return false;
    }
};
$(function () {
    cin.plugin.banners.app.init();
});
