var l = l || ((window.console !== undefined) ? window.console.log.bind(console) : function () {}),
    cin = cin || {};
cin.plugin = cin.plugin || {};
cin.plugin.fax = cin.plugin.fax || {};
cin.plugin.fax.overlayApp = {
    cfg: cin.plugin.fax.config || {},
    fax: cin.plugin.fax.app || {},
    empty: function (value) {
        return cin.plugin.fax.app.empty(value);
    },
    init: function () {
        var that = this;

        // Mark label of input field (select, input, textarea)
        $('#receiver_items input').
            focusin(function (e) {
                e.preventDefault();
                that.fax.markMatrixLabels(this, true, '.item-', 'div[class*="input_table"]');
            }).
            focusout(function (e) {
                e.preventDefault();
                that.fax.markMatrixLabels(this, false, '.item-', 'div[class*="input_table"]');
            });
        $('' +
            '.fax_cart_data select,' +
            '.fax_cart_data input,' +
            '.fax_cart_data textarea').
            focusin(function (e) {
                e.preventDefault();
                that.fax.markLabels(this, true);
            }).
            focusout(function (e) {
                e.preventDefault();
                that.fax.markLabels(this, false);
            });

        // Search customer
        $('' +
            '#receiver_items input[class*="item-number"],' +
            '#receiver_items input[class*="item-email"]' +
            '').
            blur(function (e) {
                e.preventDefault();
                that.searchReceiver(this);
            });

        // Add line(s) into matrix
        $('#receiver_items_add_line').on('click', function (e) {
            e.preventDefault();
            l('add line:', $(this));
            that.fax.ajax('ajax.php', {
                type: that.cfg.type,
                user: that.cfg.user,
                start: $('#receiver_items > div.list-lines').length,
                max: 1,
                action: 'receivers-item'
            }, null, $('#receiver_items'));
            return false;
        });
        this.initRemoves();
        this.initRemovesRequired();

        // Save and send basket offer
        $('.button-save-receiver,' +
            '.button-save-basket').on('click', function (e) {
            e.preventDefault();
            that.fax.ajax('ajax_save_basket.php', {
                type: that.cfg.type,
                user: that.cfg.user,
                uuid: !that.empty(this.cfg.uuid) ? this.cfg.uuid : '',
                relWidth: 75,
                relHeight: 75,
                action: !that.empty($(this).attr('data-action')) ?
                    $(this).attr('data-action') : 'save-basket'
            }, this);
            return false;
        });
        $('.button-send-to-receiver,' +
            '.button-save-receiver,' +
            '.button-save-basket').attr('disabled', false);
        l('overlayApp running');
    },
    searchReceiver: function (field, range) {
        var fieldname = $(field).attr('name'),
            that = this;

        this.ajax('ajax.php', {
            type: this.cfg.type,
            user: this.cfg.user,
            field: fieldname,
            search: $(field).attr('value'),
            action: 'load-receiver'
        }, field, range);
    },
    ajax: function (ajax_url, params, field) {
        var that = this;
        if (ajax_url.indexOf(this.cfg.cFrontendPfadURL) < 0) {
            ajax_url = this.cfg.cFrontendPfadURL + ajax_url;
        }
        if (!this.empty(field)) {
            params.sname = $(field).attr('data-sname');
            params.sid = $(field).attr('data-sid');
        }
        if (this.empty(params.type)) {
            params.type = this.cfg.type;
        }
        if (this.empty(params.user)) {
            params.user = this.cfg.user;
        }

        //ajax_url = ajax_url.replace('https://', 'http://');
        //l('ajax:', params, field, typeof button, !this.empty(field));
        //l('ajax:', this.cfg.cFrontendPfadURL, ' -> ', ajax_url);
        $.ajax({
            url: ajax_url,
            data: params,
            type: "POST",
            success: function (data) {
                //l('success:', data);
                var params = jQuery.parseJSON(data),
                    content = params.response,
                    result;
                if (content.length <= 0) {
                    l('success-empty:', content.length);
                    return;
                }

                if (!that.empty(content.errormsg)) {
                    l(params.fax_type + ' ajax error msgs:', content.errormsg);
                    return;
                }

                result = content.result;
                switch (params.fax_type) {
                    case 'load-receiver':
                        var fName = $(field).attr('name'),
                            fValue = $(field).attr('value'),
                            fTarget = $(field).attr('data-target'),
                            range = $(field).parent().parent().parent(),
                            inputs = range.find('input[class*="item-"]'),
                            selects = range.find('select[class*="item-"]'),
                            line = fName.substring(fName.indexOf('[') + 1, fName.indexOf(']'));
                        l(params.fax_type, ' / field:', field, ' / range:', range);
                        l(params.fax_type, ' / inputs:', inputs, ' / selects:', selects);
                        l(params.fax_type, ' / result:', result);
                        $(inputs).each(function () {
                            //if ($(this).attr('value').length == 0) {
                            fTarget = $(this).attr('data-target');
                            $(this).attr('value', result[fTarget]);
                            //}
                        });
                        $(selects).each(function () {
                            //if ($(this).attr('value').length == 0) {
                            fTarget = $(this).attr('data-target');
                            $(this).attr('value', result[fTarget]);
                            //}
                        });
                        break;
                    default:
                        l(params.fax_type);
                }
            },
            failure: function (err) {
                l('error:', err);
            }
        });
    },
    initRemovesRequired: function () {
        var parentItem = $('#receiver_items .toggle-exclude-item[data-item="0"]').parent().parent(),
            requiredFields = $(parentItem).find('input[required],select[required]').attr('name');
        l('requiredFields:', requiredFields);
    },
    initRemoves: function () {
        l('removes:', $('#receiver_items .toggle-exclude-item:not(.delete-enabled)'));
        $('#receiver_items .toggle-exclude-item:not(.delete-enabled)').on('click', function (e) {
            e.preventDefault();
            var item = $(this).attr('data-item'),
                parentItem = $('#receiver_items .toggle-exclude-item[data-item="' + item + '"]').parent().parent(),
                isDisabled;
            $(parentItem).toggleClass('disabled');
            isDisabled = $(parentItem).hasClass('disabled');
            l('remove item:', $(this), item, !isDisabled);
            $(parentItem).find('input.item-status' + item).attr('value', isDisabled ? 0 : 1);
            $(parentItem).find('input,select').attr('disabled', isDisabled);
            $(parentItem).find('input.required,select.required').prop('required', !isDisabled);
            if (isDisabled) {
                $(parentItem).find('input,select,label').addClass('disabled');
            }
            else {
                $(parentItem).find('input,select,label').removeClass('disabled');
            }
            return false;
        }).addClass('delete-enabled').addClass('toggle-btn');
    }
};
//$(function () {
l('overlayApp starting');
cin.plugin.fax.overlayApp.init();
//});
