$(document).ready(function () {
    var anchor = $('#banners');
    $(document).on('click', 'form#banners .banner-delete', function () {
        var id = $(this).attr('data-id'),
            title = $('#cTitle' + id).val();
        title = title.length > 0 ? '\'' + title + '\' ' : '';
        if (confirm('Wollen Sie den Banner ' + title + 'wirklich lschen?')) {
            $('#banner' + id).find('input[name*=\'delete\']').val('1');
            $('#banner' + id).css({'display': 'none'});
        }
        sortBanner();
    });
    anchor.sortable({
        revert: true,
        placeholder: 'placeholder',
        items: 'li.banner:not(.append)',
        stop: function (event, ui) {
            $.map($(this).find('li.banner:not(.append)'), function (element) {
                var id = $(element).attr('id'),
                    sort = $(element).index(),
                    callback;
                ui.item.css('top', '0px');
                $('li#' + id + ' input[type=hidden][name=nSort]').val(sort);
                $('li#' + id + ' h4 span.number').html(sort);
                callback = xajax.callback.create();
                callback.onComplete = function (obj) {
                };
                xajax.call('saveBanner', {
                    parameters: [xajax.getFormValues('banner' + id)],
                    callback: callback,
                    context: this
                });
            });
        }
    });
    anchor.delegate('li.banner:not(.append)', 'click', bindOverlay);
    anchor.delegate('li.banner form .banner-delete', 'click', function () {
        var callback,
            params;
        if (confirm('Wollen Sie den Banner wirklich lschen?')) {
            $(this).closest('li.banner').children('div.overlay_edit').
                children('div').children('form').children('input[name=delete]').val(1);
            callback = xajax.callback.create();
            callback.onComplete = function (obj) {
                var banner = obj.context.banner;
                $('li#' + banner.kBanner).remove();
                changeScrollPane(calcScrollPane());
            };
            params = xajax.getFormValues('banner' + $(this).closest('li.banner').attr('id'));
            xajax.call('deleteBanner', {
                parameters: [params.kBanner, params.kBanner],
                callback: callback,
                context: this
            });
        }
    });
    anchor.delegate('li.banner form button.cancel', 'click', function () {
        if (!confirm('Wollen Sie den Banner wirklich lschen?')) {
            return;
        }
        var id = $(this).closest('li.banner').attr('id');
        $('form#banner' + id).get(0).reset();
        hideOverlay(id);
        hideOverlayEdit(id);
    });
    anchor.delegate('li.banner form button[name=save]', 'click', function () {
        var id = $(this).closest('li.banner').attr('id'),
            callback;
        $('li#' + id + ' p.ajax_preloader').fadeIn('slow');
        callback = xajax.callback.create();
        callback.onComplete = function (obj) {
            var banner = obj.context.banner,
                timestamp = new Date().getTime(),
                img;
            if (banner == undefined) {
                $('li#' + id + ' div.alert-error').fadeIn().delay(3000).fadeOut('fast');
                $('li#' + id + ' p.ajax_preloader').hide();
            }
            else {
                img = $('li#' + id + ' img');
                img.attr('src', banner.cPicAbsolut);
                img.attr('reload', timestamp);
                img.addClass('banner-image');
                $('li#' + id + ' span.number').html(banner.nSort);
                $('li#' + id + ' h4').html(banner.cTitle);
                $('li#' + id + ' p:not(.ajax_preloader)').html(banner.cContent);
                $('form#banner input[name=nSort]').val(banner.nSort);
                $('form#banner input[name=cTitle]').val(banner.cTitle);
                $('form#banner input[name=cContent]').val(banner.Text);
                hideOverlay(id);
                hideOverlayEdit(id);
                $('li#' + id + ' p.ajax_preloader').hide();
            }
        };
        xajax.call('saveBanner', {
            parameters: [xajax.getFormValues('banner')],
            callback: callback,
            context: this
        });
    });
    anchor.delegate('li.banner form .select_image', 'click', function () {
        var id = $(this).closest('li.banner').attr('id'),
            kcfinderPath = $('.kcfinderPath').html();
        window.KCFinder = {
            callBack: function (url) {
                $('li#' + id + ' input[name=cPic]').val(url);
                $('li#' + id + ' div.alert-success').fadeIn().delay(3000).fadeOut('fast');
                kcFinder.close();
            }
        };
        var kcFinder = window.open(kcfinderPath + 'browse.php?type=Bilder&lang=de', 'kcfinder_textbox',
            'status=0, toolbar=0, location=0, menubar=0, directories=0, ' +
            'resizable=1, scrollbars=0, width=800, height=600,');
    });
    $('#nAnimationSpeed, #nPauseTime').change(function () {
        var nAnimationSpeed = parseInt($('#nAnimationSpeed').val()),
            nPauseTime = parseInt($('#nPauseTime').val());
        if (nAnimationSpeed > nPauseTime) {
            $('#nAnimationSpeedWarning').show();
            $('#nAnimationSpeed').addClass('nAnimationSpeedWarningBorder');
        }
        else {
            if ($('#nAnimationSpeed').hasClass('nAnimationSpeedWarningBorder')) {
                $('#nAnimationSpeedWarning').hide();
                $('#nAnimationSpeed').removeClass('nAnimationSpeedWarningBorder');
            }
        }
    });
    $('#appendBanner').click(function () {
        if ($('form#banner0 input[name=cPic]').val() != '') {
            $('li#0 p.ajax_preloader').show();
            var callback = xajax.callback.create(),
                banner;
            callback.onComplete = function (obj) {
                $('form#banner0 input[name=cTitle]').val('');
                $('form#banner0 textarea').val('');
                $('form#banner0 input[name=cPic]').val('');
                $('form#banner0 input[name=cLink]').val('');
                banner = obj.context.banner;
                $('li#0 p.ajax_preloader').hide();
                if (banner == undefined) {
                    $('li#0 div.alert-error').fadeIn().delay(3000).fadeOut('fast');
                }
                else {
                    addBanner(banner);
                }
            };
            xajax.call('saveBanner', {
                parameters: [xajax.getFormValues('banner' + $(this).closest('li.banner').attr('id'))],
                callback: callback,
                context: this
            });
        }
        else {
            alert('Sie mssen ein Bild fr den neuen Banner auswhlen, bevor Sie diesen hinzufgen knnen!');
        }
    });
    $('.random_effects').click(function () {
        if ($('#cRandomEffects').prop('checked')) {
            $('select[name=cSelectedEffects]').attr('disabled', true);
            $('select[name=cAvaibleEffects]').attr('disabled', true);
            $('button.select_add').attr('disabled', true);
            $('button.select_remove').attr('disabled', true);
            $('input[type=hidden][name=cEffects]').attr('disabled', true);
            $('select[name=cSelectedEffects]').html('');
        }
        else {
            $('select[name=cSelectedEffects]').removeAttr('disabled');
            $('select[name=cAvaibleEffects]').removeAttr('disabled');
            $('button.select_add').removeAttr('disabled');
            $('button.select_remove').removeAttr('disabled');
            $('input[type=hidden][name=cEffects]').removeAttr('disabled');
        }
    });
    $('form#banner').submit(function () {
        if ($('.random_effects').prop('checked') !== true) {
            var effects = new Array();
            $.each($('select[name=cSelectedEffects] option'), function (index, value) {
                effects[index] = $(this).val();
            });
            $('input[name=cEffects]').val(effects.join(';'));
        }
    });
    $('button.select_add').click(function () {
        $.each($('select[name=cAvaibleEffects]').val(), function (index, value) {
            var exists = false,
                html;
            $.each($('select[name=cSelectedEffects] option'), function (element) {
                if ($(this).val() == value) {
                    exists = true;
                }
            });
            if (exists == false) {
                html = '<option value="' + value + '">' + value + '</option>';
                $('select[name=cSelectedEffects]').append(html);
            }
            else {
                alert('Der Eintrag mit den Wert "' + value + '" existiert bereits!');
            }
        });
    });
    $('button.select_remove').click(function () {
        $.each($('select[name=cSelectedEffects] option:selected'), function (index, value) {
            $(this).remove();
        });
    });
    $("select[name='nPageType']").change(function () {
        var selected = $("select[name='nPageType'] option:selected");
        typeChanged($(selected).val());
    }).change();
    $("select[name='cKey']").change(function () {
        var selected = $("select[name='cKey'] option:selected");
        keyChanged($(selected).val());
    }).change();
    $('.nl').find('a').each(function () {
        var type = $(this).attr('id');
        $(this).click(function () {
            show_simple_search(type);
        });
    });
    init_simple_search(function (type, res) {
        $(".nl input[name='" + type + "_key']").val(res.kKey);
        $(".nl input[name='" + type + "_name']").val(res.cName);
    });
});

function typeChanged(type) {
    $('.custom').hide();
    $('#type' + type).show();
    if (type != 2) {
        $('select[name="cKey"]').val('');
        $('.nl .key').hide();
        $('.nl input[type="text"], .nl input[type="hidden"]').each(function () {
            $(this).val('');
        });
    }
}

function keyChanged(key) {
    $('.key[id!="key' + key + '"]').find('input').each(function () {
        $(this).val('');
    });
    $('.key').hide();
    $('#key' + key).show();
}

function hideOverlayEdit(id) {
    $('li#' + id).find('div.overlay_edit').fadeOut('fast');
}

function hideOverlay(id) {
    var elem = $('li#' + id);
    elem.removeClass('active').addClass('inactive');
    elem.find('div.overlay').fadeOut('fast');
    hideOverlayEdit(id);
}

$(function () {
    $("#tableBanner tbody ").sortable({
        containerSelector: 'table',
        itemPath: '> tbody',
        itemSelector: 'tr',
        opacity: '0',
        axis: "y",
        cursor: "move",
        cursorAt: {top: 5},
        stop: function (item) {
            sortBanner();
        }
    });
});

var kcFinder;
function selectImage(id) {
    var kcfinderPath = $('.kcfinderPath').html();
    window.KCFinder = {
        callBack: function (url) {
            $('#img' + id).attr('src', url);
            $('input[name="banners\[' + id + '\]\[cPic\]"]').val(url);
            kcFinder.close();
        }
    };
    if (kcFinder && !kcFinder.closed) {
        kcFinder.close();
    }
    kcFinder = window.open(kcfinderPath + 'browse.php?type=Bilder&lang=de', 'kcfinder_textbox',
        'status=0, toolbar=0, location=0, menubar=0, directories=0, ' +
        'resizable=1, scrollbars=0, width=800, height=600,');
}

var count = 0;
function addBanner(banner) {
    var newBanner = $('#newBanner').html(),
        bannerID = 'neu' + count;
    newBanner = newBanner.replace(/NEU/g, bannerID);
    $('#tableBanner tbody').append(newBanner);
    if (typeof cin !== 'undefined') {
        cin.plugin.banners.app.addDatepicker('#cTimer' + bannerID, 'addBanner');
        cin.plugin.banners.app.addLinkChecker(bannerID);
    }
    count++;
    sortBanner();
}

function sortBanner() {
    $("input[name*='\[nSort\]']").each(function (index) {
        $(this).val(index + 1);
    });
}

function bindOverlay() {
    if ($(this).find('div.overlay_edit').css('display') === 'none') {
        $(this).find('div.overlay').fadeIn('fast');
        $(this).find('div.overlay_edit').fadeIn('fast');
    }
}
