{if isset($smarty.session.pq_new_cinmsg) && is_array($smarty.session.pq_new_cinmsg)}
    {""|implode:$smarty.session.pq_new_cinmsg}
{elseif isset($smarty.session.pq_new_cinmsg)}
    {$smarty.session.pq_new_cinmsg}
{/if}
<div id="dashboard">
    <div class="hidden" id="header-info">
        {if $pluginStatus != ''}
            <table class="plugin-infos tiny">
                <tbody>
                    <tr>
                        <td class="status-msg {$licenceCSS}">
                            <span>{$pluginStatus}</span>
                        </td>
                    </tr>
                </tbody>
            </table>
        {/if}
        <table class="plugin-infos tiny">
            <tbody>
                <tr>
                    <td>Lizenz:</td>
                    <td>
                        {strip}
                            <span class="licence-msg {$licenceCSS}">
                                {$licence|ucfirst}
                                {if $licence == 'demo'}
                                    , <span class="text-nowrap">{timeElapsed timestamp=$remainingTime invert=true showPrefix=true}</span>
                                {/if}
                            </span>
                        {/strip}
                    </td>
                </tr>
                {if $installDate|@strlen > 0}
                    <tr>
                        <td>Installiert am:</td>
                        <td>{$installDate|replace:' - ':' &nbsp;'}</td>
                    </tr>
                {/if}
                {if $registerDate|@strlen > 0}
                    <tr>
                        <td>Registriert am:</td>
                        <td>{$registerDate|replace:' - ':' &nbsp;'}</td>
                    </tr>
                {/if}
                <tr>
                    <td>Installierte Version:</td>
                    <td>
                        {strip}
                            {if $installedVersion|intval == 0}
                                <span class="version installed unknown small">Zur Zeit nicht verfgbar</span>
                            {else}
                                <span class="version installed {$licenceCSS}">
                                    {$installedVersion}
                                </span>
                            {/if}
                            {if $versionDiff > 0}
                                <span> &rarr; </span>
                                <span class="version current updatable {$licenceCSS}">
                                    {$currentVersion}
                                </span>
                            {/if}
                        {/strip}
                    </td>
                </tr>
            </tbody>
        </table>
        {if $versionDiff > 0}
            <table class="plugin-infos tiny">
                <tbody>
                    <tr>
                        <td class="no-margin no-padding" data-available="{$dlAvailable|var_export}" data-file="{$downloadFile}">
                            {if isset($dlAvailable) && $dlAvailable == true && $downloadFile|strlen > 0}
                                {strip}
                                    <a class="new-version btn btn-default" href="{$downloadFile}">
                                        <i class="fa fa-download"></i> Neue Version verfgbar
                                    </a>
                                {/strip}
                            {else}
                                {strip}
                                    <a class="new-version btn btn-default text-left padding-5" target="_blank" href="{$downloadHost}">
                                        <i class="fa fa-download"></i> Neue Version verfgbar, <br/>
                                        <i class="fa fa-fw-spacer"></i> Download via Com-ins-Netz.de
                                    </a>
                                {/strip}
                            {/if}
                        </td>
                    </tr>
                </tbody>
            </table>
        {/if}
    </div>

    {if (isset($xselling) && !empty($xselling))}
        <div id="cin-plugin-xselling">
            <h2>Unsere Empfehlungen</h2>
            {$xselling}
        </div>
    {/if}

    {if (isset($news) && !empty($news))}
        <div id="cin-plugin-news">
            <h2>Unsere News</h2>
            {$news}
        </div>
    {/if}
</div>

{literal}
    <script>
        $(function () {
            try {
                if (typeof cin.base.plugin.init != 'function') {
                    $('#header-info').removeClass('hidden');
                    console.log('new dashboard');
                }
            }
            catch (ex) {
                $('#header-info').removeClass('hidden');
                console.log('new dashboard');
            }
        });
    </script>
{/literal}
